      program map
c
      parameter (jpobs=200)
c
      integer ii1(jpobs),iii1(jpobs),lat1(jpobs),lon1(jpobs)
      real   pobs1(jpobs),tobs1(jpobs)
      integer pflag1(jpobs),tflag1(jpobs)
c
c
      integer ii2(jpobs),iii2(jpobs),lat2(jpobs),lon2(jpobs)
      real   pobs2(jpobs),tobs2(jpobs)
      integer pflag2(jpobs),tflag2(jpobs)
c
      parameter (jplon=50,jplat=50)
c
      real  x(jplon*jplat), y(jplon*jplat),
     x	   xp(jplon*jplat),yp(jplon*jplat),
     x	    p1(jplon*jplat), t1(jplon*jplat),
     x	    p2(jplon*jplat), t2(jplon*jplat)
c
      character*1 lin(4*(jplon+2)*(jplat+2))
c
#include "comdef.inc"
c
      character*4  monname(12)
      character*9  dayname
      character*64 text(1)
c
c------------------------------------------------------------------------------
c
c     selection of map characteristics.
c
      character*40 driver,device
      integer bgcol
      integer ifldthi,ifldcol
      integer ifrathi,ifracol,icoathi,icoacol,ilatthi,ilatcol
      integer ilabthi,ilabcol,ilogthi,ilogcol
      logical lcoast,llatlon,llogo
      character*1 clbase
      real latmin,latmax,idlat,lonmin,lonmax,idlon
      real hgtlog
c
#include "comrep.inc"
c
      namelist/namge2/
     +	      bgcol,driver,device,
     +	      llatlon,lcoast,llogo,
     +        ifldthi,ifldcol,
     +	      ifrathi,ifracol,icoathi,icoacol,ilatthi,ilatcol,
     +	      ilabthi,ilabcol,ologthi,ilogcol,
     +	      ltotal,maprep,scale,hgtlog,
     +	      prolat,prolon,latmid,lonmid,dxmap,dymap,
     +	      latmin,latmax,idlat,lonmin,lonmax,idlon,
     +	      clbase
c
c
      integer year,month,day,hour
      character*3 expnam1,expnam2
      real hgttxt,obssize,disop,disot
      logical tplot,pplot
      namelist/namex2/year,month,day,hour,expnam1,expnam2,
     x		      hgttxt,obssize,
     x		      disop,disot
c
      character*12 filnam
      character*4  varnam
c
c-----------------------------------------------------------------------------
c
c    defaults for namelist input
c
c   namgeo:
c   --------------------
      data xorigo/5/,yorigo/15/
      data llatlon/.false./,lcoast/.false./,llogo/.true./
      data ifldthi/20/,ifldcol/27/
      data icoathi/3/,ifrathi/50/,ilabthi/2/,ilatthi/1/
      data icoacol/5/,ifracol/6/,ilabcol/7/,ilatcol/8/
      data ilogthi/2/,ilogcol/9/,hgtlog/1.00/
      data latmin/ 30./,latmax/75./,idlat/15./
      data lonmin/-90./,lonmax/90./,idlon/15./
      data prolat/60./,latmid/90/,lonmid/00/,dxmap/20./,dymap/20./
      data prolon/0./
      data clbase /'g'/
      data bgcol /0/
      data obssize /0.3/
      data hgttxt /0.3/
      data disop /2./
      data disot /2./
c
c-----------------------------------------------------------------------------
c
c     other defaults:
c
c
      data monname/' jan',' feb',' mar',' apr',' may',' jun',
     +             ' jul',' aug',' sep',' oct',' nov',' dec'/
c
      do 100 i=1,1
      do 100 j=1,64
      text(i)(j:j)=' '
  100 continue
c
      open(unit=55,file='namge2.dat')
      read(55,namge2)
      close(unit=55)
      open(unit=55,file='namex2.dat')
      read(55,namex2)
      close(unit=55)
c
      iy=year-year/100*100
      write(filnam,'(i2.2,i2.2,i2.2,i2.2,a1,a3)')
     x			  iy,month,day,hour,'.',expnam1
      lunin = 10
      open(unit=lunin,file=filnam)
      read(lunin,*)nlon,nlat,alats,alonw,dtheta,dlamda
      npoint=nlon*nlat
      read(lunin,'(a)') text
      write(6,*) 'read : ',text
      read(lunin,*)(p1(k),k=1,npoint)
      read(lunin,'(a)') text
      write(6,*) 'read : ',text
      read(lunin,*)(t1(k),k=1,npoint)
      do 120 k=1,npoint
      t1(k) = t1(k) - 273.2
  120 continue
      nobs1=0
      read(lunin,'(a)') text
      write(6,*) 'read : ',text
  150 read(lunin,*,end=200)ii1(nobs1+1),iii1(nobs1+1),
     x		   lat1(nobs1+1),lon1(nobs1+1),
     x		   pobs1(nobs1+1),tobs1(nobs1+1),pflag1(nobs1+1),
     x		   tflag1(nobs1+1)
      nobs1=nobs1+1
      goto 150
  200 continue
      close(unit=lunin)
c
      iy=year-year/100*100
      write(filnam,'(i2.2,i2.2,i2.2,i2.2,a1,a3)')
     x			  iy,month,day,hour,'.',expnam2
      lunin = 10
      open(unit=lunin,file=filnam)
      read(lunin,*)nlon,nlat,alats,alonw,dtheta,dlamda
      npoint=nlon*nlat
      read(lunin,'(a)') text
      write(6,*) 'read : ',text
      read(lunin,*)(p2(k),k=1,npoint)
      read(lunin,'(a)') text
      write(6,*) 'read : ',text
      read(lunin,*)(t2(k),k=1,npoint)
      do 210 k=1,npoint
      t2(k) = t2(k) - 273.2
  210 continue
      nobs2=0
      read(lunin,'(a)') text
      write(6,*) 'read : ',text
  220 read(lunin,*,end=230)ii2(nobs2+1),iii2(nobs2+1),
     x		   lat2(nobs2+1),lon2(nobs2+1),
     x		   pobs2(nobs2+1),tobs2(nobs2+1),pflag2(nobs2+1),
     x		   tflag2(nobs2+1)
      nobs2=nobs2+1
      goto 220
  230 continue
      close(unit=lunin)
c
      irep=0
      alatn=alats+(nlat-1)*dtheta
      alone=alonw+(nlon-1)*dlamda
      alatnp=90.
      alonnp=0.
c
c
c     1.2  set date and time.
c	   ------------------
c
      if( year.gt.0 .and. year.lt.100 )then
	 year = year + 1900
      endif
c
c     1.3  write time label string.
c	    ------------------------
c
      call weekday(year,month,day,dayname,lholy)
c
c     4.1  set up the geometry.
c	    ---------------------
c
      nona=nlon*nlat
      call xyplot(nona,x,y,xmin,xmax,ymin,ymax)
      call iniobs(xmin,xmax,ymin,ymax)
c
      do 300 k=1,nona
      x(k) = x(k) + xorigo
      y(k) = y(k) + yorigo
  300 continue
c
      xmin = xmin + xorigo
      xmax = xmax + xorigo
      ymin = ymin + yorigo
      ymax = ymax + yorigo
c
      pplot=.true.
      varnam='pres'
      tplot=.false.
c
      do 5000 kmap=1,2
c      write(6,*)' vilket flt vill du se ? (1=tryck,2=temperatur)'
c      read(5,*)kmap
      if(kmap.eq.2)then
         pplot=.false.
         tplot=.true.
         varnam='temp'
      endif
c
      call plotex('POST',.false.)
c
      write(text(1)(1:38),
     +	       '(a4,a1,a3,a2,a9,i3,a4,i5,1x,i2.2,a4)')varnam,
     +	 ' ',expnam1,'  ',dayname,day,monname(month),year,hour,
     +	    ' utc'
c
      call newpex(ilabthi,ilabcol)
      call symbex(xorigo+0.25,yorigo-0.75,0.25,text(1),0.,64)
c
c----------------------------------------------------------------------------
c
      if(lcoast)then
c     coastlines
      write(6,*) 'icoathi=',icoathi
      call newpex(icoathi,icoacol)
      ltypec = 1
      call coast(xp,yp,ltypec,xmin,xmax,ymin,ymax,xorigo,yorigo,
     x           clbase)
      endif

      if(llatlon)then
c     latitudes and longitudes. latitude +-90 singular, not possible.
      if(latmin.lt.-85.)latmin=-85.
      if(latmax.gt. 85.)latmax= 85.
      call newpex(ilatthi,ilatcol)
      call latlon(latmin,latmax,idlat,lonmin,lonmax,idlon,
     +	 hgttxt,xmin,xmax,ymin,ymax,xorigo,yorigo,xp,yp,jplon*jplat)
      endif
c  
      if(llogo)then
      call newpex(ilogthi,ilogcol)
      xlog=xmax-2.5
      ylog=ymin-0.80
      call logo(xlog,ylog,0.6*hgtlog)
      endif
c
c
      nsmut = 5
      ltype = 1
      mrkfrq = 1
      mrkdec = 0
      hgtmrk = 0.5*hgttxt
c
      call newpex(ifldthi,ifldcol)
c
      if( pplot ) then
c
	 zmin=900.
	 zmax=1500.
c
	 if(disop.lt.1) mrkdec = 1
	 call isolin(p1,x,y,nlon,nlat,disop,zmin,zmax,nsmut,ltype,
     x			mrkfrq,mrkdec,hgtmrk,.true.,
     x			1,xmin,xmax,ymin,ymax,
     x			jplon*jplat,xp,yp,lin)
c
      else if( tplot ) then
c
	 zmin=-100.
	 zmax=+100.
c
	 if(disot.lt.1) mrkdec = 1
	 call isolin(t1,x,y,nlon,nlat,disot,zmin,zmax,nsmut,ltype,
     x			mrkfrq,mrkdec,hgtmrk,.true.,
     x			1,xmin,xmax,ymin,ymax,
     x			jplon*jplat,xp,yp,lin)
c
      endif
c
c
      call obsar(tplot,pplot,nobs1,ii1,iii1,lat1,lon1,
     x		       pobs1,tobs1,pflag1,tflag1,
     x		       obssize,xorigo,yorigo,xmin,xmax,ymin,ymax)
c
      call newpex(ifrathi,ifracol)
      call framex(xmin,xmax,ymin,ymax)
      call framex(xmin,xmax,ymin-1.0,ymin)
c
      yorigo = yorigo - dymap - 1.5
      do 1300 k=1,nona
      y(k) = y(k) - dymap - 1.5
 1300 continue
c
      ymin = ymin - dymap - 1.5
      ymax = ymax - dymap - 1.5
c
      write(text(1)(1:38),
     +	       '(a4,a1,a3,a2,a9,i3,a4,i5,1x,i2.2,a4)')varnam,
     +	 ' ',expnam2,'  ',dayname,day,monname(month),year,hour,
     +	    ' utc'
c
      call newpex(ilabthi,ilabcol)
      call symbex(xorigo+0.25,yorigo-0.75,0.25,text(1),0.,64)
c
c----------------------------------------------------------------------------
c
      if(lcoast)then
c     coastlines
      write(6,*) 'icoathi=',icoathi
      call newpex(icoathi,icoacol)
      ltypec = 1
      call coast(xp,yp,ltypec,xmin,xmax,ymin,ymax,xorigo,yorigo,
     x           clbase)
      endif

      if(llatlon)then
c     latitudes and longitudes. latitude +-90 singular, not possible.
      if(latmin.lt.-85.)latmin=-85.
      if(latmax.gt. 85.)latmax= 85.
      call newpex(ilatthi,ilatcol)
      call latlon(latmin,latmax,idlat,lonmin,lonmax,idlon,
     +	 hgttxt,xmin,xmax,ymin,ymax,xorigo,yorigo,xp,yp,jpvec)
      endif
c  
      if(llogo)then
      call newpex(ilogthi,ilogcol)
      xlog=xmax-2.5
      ylog=ymin-0.80
      call logo(xlog,ylog,0.6*hgtlog)
      endif
c
c
      nsmut = 5
      ltype = 1
      mrkfrq = 1
      mrkdec = 0
      hgtmrk = 0.5*hgttxt
c
      call newpex(ifldthi,ifldcol)
c
      if( pplot ) then
c
	 zmin=900.
	 zmax=1500.
c
	 if(disop.lt.0) mrkdec = 1
	 call isolin(p2,x,y,nlon,nlat,disop,zmin,zmax,nsmut,ltype,
     x			mrkfrq,mrkdec,hgtmrk,.true.,
     x			1,xmin,xmax,ymin,ymax,
     x			jplon*jplat,xp,yp,lin)
c
      else if( tplot ) then
c
	 zmin=-100.
	 zmax=+100.
c
	 if(disot.lt.0) mrkdec = 1
	 call isolin(t2,x,y,nlon,nlat,disot,zmin,zmax,nsmut,ltype,
     x			mrkfrq,mrkdec,hgtmrk,.true.,
     x			1,xmin,xmax,ymin,ymax,
     x			jplon*jplat,xp,yp,lin)
c
      endif
c
c
      call obsar(tplot,pplot,nobs2,ii2,iii2,lat2,lon2,
     x		       pobs2,tobs2,pflag2,tflag2,
     x		       obssize,xorigo,yorigo,xmin,xmax,ymin,ymax)
c
      call newpex(ifrathi,ifracol)
      call framex(xmin,xmax,ymin,ymax)
      call framex(xmin,xmax,ymin-1.0,ymin)
c
      yorigo = yorigo + dymap + 1.5
      do 2300 k=1,nona
      y(k) = y(k) + dymap + 1.5
 2300 continue
c
      ymin = ymin + dymap + 1.5
      ymax = ymax + dymap + 1.5
c
      call endex
c
      pplot=.false.
      tplot=.true.
      varnam='temp'
c
      call system('gs POST')
 5000 continue

      stop

      end
