
      subroutine iso2(x,y,m,n,frame,
     x                igrid,xmin,xmax,ymin,ymax,
     x                maxvec,xp,yp,lin)
c
      implicit none
c
      integer m,n
      real x(m,n),y(m,n)
      integer igrid,maxvec
      real xmin,xmax,ymin,ymax
      real xp(maxvec),yp(maxvec)
      character*1 lin(4,0:m+1,0:n+1)
      logical frame
c
c---------------------------------------------------------------------
c
      integer mstep,nstep,i,j,nr,n1,n2,jd,id
      real xsave,ysave
c
c---------------------------------------------------------------------
c
      if( frame ) then
         call framex(xmin,xmax,ymin,ymax)
      endif
c
      if( igrid.eq.1 ) then
         mstep = m - 1
         nstep = n - 1
      else if( igrid.eq.2 ) then
         mstep = 1
         nstep = 1
      else
         goto 80
      endif
c
      do 30 j=1,n,nstep
         do 25 i=1,m
            xp(i) = x(i,j)
            yp(i) = y(i,j)
   25    continue
         nr = m
   27    call inline(xp,yp,nr,xmin,xmax,ymin,ymax,n1,n2,
     x                  xsave,ysave)
         if(n1.gt.0) then
            xp(n2+1)=0.
            xp(n2+2)=1.
            yp(n2+1)=0.
            yp(n2+2)=1.
            call linex(xp(n1),yp(n1),n2-n1+1,1)
         endif
         if( n1.le.1 ) goto 30
         xp(n1) = xsave
         yp(n1) = ysave
         nr = n1
         goto 27
c
   30 continue
c
c
      do 40 i=1,m,mstep
         do 35 j=1,n
            xp(j) = x(i,j)
            yp(j) = y(i,j)
   35    continue
         nr = n
   38    call inline(xp,yp,nr,xmin,xmax,ymin,ymax,n1,n2,
     x                  xsave,ysave)
         if(n1.gt.0) then
            xp(n2+1)=0.
            xp(n2+2)=1.
            yp(n2+1)=0.
            yp(n2+2)=1.
            call linex(xp(n1),yp(n1),n2-n1+1,1)
         endif
         if( n1.le.1 ) goto 40
         xp(n1) = xsave
         yp(n1) = ysave
         nr = n1
         goto 38
c
   40 continue
c
c
   80 continue
c
c
      do 82 j=0,n+1
         do 82 i=0,m+1
   82 lin(4,i,j) = '0'
      do 86 j=1,n
         do 86 i=1,m
            if( x(i,j).ge.xmin .and. x(i,j).le.xmax .and.
     x         y(i,j).ge.ymin .and. y(i,j).le.ymax ) then
               do 84 jd=-1,1
                  do 84 id=-1,1
   84            lin(4,i+id,j+jd) = '1'
            endif
   86 continue
c
      call kulout(m,n,x,y,lin,xmin,ymin)
c
      return
c
      end

