
      subroutine concrv(x,y,n,zvalue,nsmut,ltype,
     x    nline,mrkfrq,mrkdec,hgtmrk,xmin,xmax,ymin,ymax)
      integer n
      real x(n),y(n)
      real zvalue
      integer nsmut,ltype,nline,mrkfrq,mrkdec
      real hgtmrk
c
#include "comgks.inc"
c
      real eps,cradi
      logical closed
c
      data eps /1.e-6/
      data cradi /57.295780/
c
      lltype = ltype
      if( ltype.eq.4 .or. ltype.eq.5 ) then
         if( zvalue.ge.0. ) then
            lltype = 1
         else
            lltype = 2
         endif
      endif
c
      if( ltype.eq.5 .and. abs(zvalue).lt.eps ) return

cxyh  highlight zero line
      if( ltype.eq.6 ) then
         lltype = 1
         if(abs(zvalue).lt.eps ) then
	   ithpen = 5.0
	   call newpex(ithpen,icopen)
	 else
	   ithpen = 1.0
	   call newpex(ithpen,icopen)
	 endif
      endif
c
      ndig = 1
      if( abs(zvalue).ge.  9.9999 ) ndig = 2
      if( abs(zvalue).ge. 99.9999 ) ndig = 3
      if( abs(zvalue).ge.999.9999 ) ndig = 4
      if( zvalue.lt.0. ) ndig = ndig + 1
      if( mrkdec.gt.0 ) ndig = ndig + mrkdec + 1
      dischr=float(ndig+1)*hgtmrk*0.8
c
      if( nsmut.gt.0 ) then
c
         do 100 k=n,2,-1
c
         x(5*(k-1)+1) = x(k)
         y(5*(k-1)+1) = y(k)
c
         x(5*(k-1)) = 0.8*x(k) + 0.2*x(k-1)
         y(5*(k-1)) = 0.8*y(k) + 0.2*y(k-1)
c
         x(5*(k-1)-1) = 0.6*x(k) + 0.4*x(k-1)
         y(5*(k-1)-1) = 0.6*y(k) + 0.4*y(k-1)
c
         x(5*(k-1)-2) = 0.4*x(k) + 0.6*x(k-1)
         y(5*(k-1)-2) = 0.4*y(k) + 0.6*y(k-1)
c
         x(5*(k-1)-3) = 0.2*x(k) + 0.8*x(k-1)
         y(5*(k-1)-3) = 0.2*y(k) + 0.8*y(k-1)
c
  100    continue
c
         n=5*(n-1)+1
c
         closed = .false.
         if( abs(x(1)-x(n)).lt.eps .and.
     x       abs(y(1)-y(n)).lt.eps ) closed = .true.
         do 300 ismut=1,nsmut
         xsave=x(1)
         ysave=y(1)
         do 200 k=2,n-1
         xxxx=x(k)+0.25*(x(k+1)+x(k-1)-2.*x(k))
         yyyy=y(k)+0.25*(y(k+1)+y(k-1)-2.*y(k))
         x(k-1)=xsave
         y(k-1)=ysave
         xsave=xxxx
         ysave=yyyy
  200    continue
         x(n-1)=xsave
         y(n-1)=ysave
         if( closed ) then
            xxxx=x(n)+0.25*(x(2)+x(n-1)-2.*x(n))
            yyyy=y(n)+0.25*(y(2)+y(n-1)-2.*y(n))
            x(n)=xxxx
            y(n)=yyyy
            x(1)=xxxx
            y(1)=yyyy
         endif
  300    continue
      endif
      x(n+1)=0.
      x(n+2)=1.
      y(n+1)=0.
      y(n+2)=1.
c
c
      if( n.lt.5 .or.
     x    nline/mrkfrq*mrkfrq.ne.nline ) then
c
         call linex(x,y,n,lltype)
c
      else
c
         nn=n/2
         nn1=nn
         nn2=nn+1
c
  320    dist = sqrt((x(nn1)-x(nn2))**2+(y(nn1)-y(nn2))**2)
         if( dist.ge.dischr ) goto 390
c
         if( nn2.lt.n .and.
     x       (x(nn2+1)-x(nn2))*(x(nn+1)-x(nn)).ge.0. )then
            nn2=nn2+1
            goto 320
         endif
c
         if( nn1.gt.1 .and.
     x       (x(nn1)-x(nn1-1))*(x(nn+1)-x(nn)).ge.0. )then
            nn1=nn1-1
            goto 320
         endif
c
         nnnn = 1
         goto 900
c
  390    ang=atan2(y(nn1)-y(nn2),x(nn1)-x(nn2))*cradi
	 clndis = (xmax-xmin)*0.04
	 if(x(nn1).le.xmin+clndis .or. x(nn1).ge.xmax-clndis .or.
     1      y(nn1).le.ymin+clndis .or. y(nn1).ge.ymax-clndis ) then
		nnnn = 1
		goto 900
	 endif
         sinang = (y(nn2)-y(nn1))/dist
         cosang = (x(nn2)-x(nn1))/dist
         xsave = x(nn1) + cosang*dischr
         ysave = y(nn1) + sinang*dischr
         zhgt = 0.2*hgtmrk
         x1ch = x(nn1) + cosang*zhgt
         y1ch = y(nn1) + sinang*zhgt
         x2ch = xsave  - cosang*zhgt
         y2ch = ysave  - sinang*zhgt
         if( ang.lt.-90. ) ang=ang+180.
         if( ang.gt.+90. ) ang=ang-180.
         nnnn=nn1
         xnnp1=x(nnnn+1)
         ynnp1=y(nnnn+1)
         xnnp2=x(nnnn+2)
         ynnp2=y(nnnn+2)
         x(nnnn+1)=0.
         x(nnnn+2)=1.
         y(nnnn+1)=0.
         y(nnnn+2)=1.
c
         call linex(x,y,nnnn,lltype)
c
         x(nnnn+1)=xnnp1
         y(nnnn+1)=ynnp1
         x(nnnn+2)=xnnp2
         y(nnnn+2)=ynnp2
c
         zhgt = hgtmrk*0.5
         if( x1ch.lt.x2ch ) then
            xx = x1ch + zhgt*sinang
            yy = y1ch - zhgt*cosang
         else
            xx = x2ch - zhgt*sinang
            yy = y2ch + zhgt*cosang
         endif
c
         call numbex(xx,yy,hgtmrk,zvalue,ang,ndig,mrkdec)
c
  800    nnnn=nn2-1
         x(nnnn) = xsave
         y(nnnn) = ysave
c
  900    call linex(x(nnnn),y(nnnn),n-nnnn+1,lltype)
c
      endif
      return
      end

