c     +---------------------------------------------------+
c     + subroutine : guassian filter                      +
c     +---------------------------------------------------+
      subroutine GF(idim,jdim,a,b,igcut,jgcut,g)

      implicit  none
      integer 	idim,jdim,igcut,jgcut
      real 	a(idim,jdim),b(idim,jdim),
     +		g(-igcut:igcut,-jgcut:jgcut)

      integer i,j,ig,jg

      do i=1,idim
      do j=1,jdim
	 b(i,j) = 0.
      enddo
      enddo
      do ig=-igcut,igcut
      do jg=-jgcut,jgcut
         do i=1,idim
         do j=1,jdim
	    if(i+ig.ge.1 .and. i+ig.le.idim .and.
     1	       j+jg.ge.1 .and. j+jg.le.jdim)
     2	    b(i,j) = b(i,j) + g(ig,jg)*a(i+ig,j+jg)
	 enddo
	 enddo
      enddo
      enddo
      end
